PingOne Platform APIs

Step: Create the Application Role Assignment

POST {{apiPath}}/v1/environments/{{envID}}/applications/{{appID}}/roleAssignments

When you assign a role to an application, you need to identify the role to assign, and designate the scope for role.

Use the POST {{apiPath}}/v1/environments/{{envID}}/applications/{{appID}}/roleAssignments operation to create the role assignment for the application in the specified environment.

The request URL identifies the environment ID and application ID. The request body specifies the role ID and the scope to use for the role assignment.

For this activity, the scope type is ENVIRONMENT and the specific environment to which the role assignment scope applies is specified in the id value.

Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

Body

raw ( application/json )

{
    "role": {
        "id": "{{roleID}}"
    },
    "scope": {
        "id": "{{envID}}",
        "type": "ENVIRONMENT"
    }
}

Example Request

  • cURL

  • C#

  • Go

  • HTTP

  • Java

  • jQuery

  • NodeJS

  • Python

  • PHP

  • Ruby

  • Swift

curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/applications/{{appID}}/roleAssignments' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "role": {
        "id": "{{roleID}}"
    },
    "scope": {
        "id": "{{envID}}",
        "type": "ENVIRONMENT"
    }
}'
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/applications/{{appID}}/roleAssignments")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""role"": {" + "\n" +
@"        ""id"": ""{{roleID}}""" + "\n" +
@"    }," + "\n" +
@"    ""scope"": {" + "\n" +
@"        ""id"": ""{{envID}}""," + "\n" +
@"        ""type"": ""ENVIRONMENT""" + "\n" +
@"    }" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/applications/{{appID}}/roleAssignments"
  method := "POST"

  payload := strings.NewReader(`{
    "role": {
        "id": "{{roleID}}"
    },
    "scope": {
        "id": "{{envID}}",
        "type": "ENVIRONMENT"
    }
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
POST /v1/environments/{{envID}}/applications/{{appID}}/roleAssignments HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "role": {
        "id": "{{roleID}}"
    },
    "scope": {
        "id": "{{envID}}",
        "type": "ENVIRONMENT"
    }
}
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"role\": {\n        \"id\": \"{{roleID}}\"\n    },\n    \"scope\": {\n        \"id\": \"{{envID}}\",\n        \"type\": \"ENVIRONMENT\"\n    }\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/applications/{{appID}}/roleAssignments")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/applications/{{appID}}/roleAssignments",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "role": {
      "id": "{{roleID}}"
    },
    "scope": {
      "id": "{{envID}}",
      "type": "ENVIRONMENT"
    }
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/applications/{{appID}}/roleAssignments',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "role": {
      "id": "{{roleID}}"
    },
    "scope": {
      "id": "{{envID}}",
      "type": "ENVIRONMENT"
    }
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/applications/{{appID}}/roleAssignments"

payload = json.dumps({
  "role": {
    "id": "{{roleID}}"
  },
  "scope": {
    "id": "{{envID}}",
    "type": "ENVIRONMENT"
  }
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/applications/{{appID}}/roleAssignments');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "role": {\n        "id": "{{roleID}}"\n    },\n    "scope": {\n        "id": "{{envID}}",\n        "type": "ENVIRONMENT"\n    }\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/applications/{{appID}}/roleAssignments")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "role": {
    "id": "{{roleID}}"
  },
  "scope": {
    "id": "{{envID}}",
    "type": "ENVIRONMENT"
  }
})

response = http.request(request)
puts response.read_body
let parameters = "{\n    \"role\": {\n        \"id\": \"{{roleID}}\"\n    },\n    \"scope\": {\n        \"id\": \"{{envID}}\",\n        \"type\": \"ENVIRONMENT\"\n    }\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/applications/{{appID}}/roleAssignments")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()

Example Response

{
  "_links": {
    "self": {
      "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/applications/b844756f-f742-4451-af0f-fed587dfe0a9/roleAssignments/dc95ead2-23f8-4c35-a4b3-0d8a188685ab"
    },
    "application": {
      "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/applications/b844756f-f742-4451-af0f-fed587dfe0a9"
    },
    "environment": {
      "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    }
  },
  "id": "dc95ead2-23f8-4c35-a4b3-0d8a188685ab",
  "scope": {
    "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6",
    "type": "ENVIRONMENT"
  },
  "role": {
    "id": "ebb05620-780b-472c-9f70-d8546f14a032"
  },
  "environment": {
    "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
  },
  "readOnly": false,
  "application": {
    "id": "b844756f-f742-4451-af0f-fed587dfe0a9"
  }
}